"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.comment = void 0;
const els_1 = require("../support/els");
const helpers_1 = require("../support/helpers");
const utils_1 = require("../support/utils");
function comment(context, comment, headingLevel) {
    var _a, _b;
    const md = [];
    if (((_a = comment.summary) === null || _a === void 0 ? void 0 : _a.length) > 0) {
        md.push(context.partials.commentParts(comment.summary));
    }
    if ((_b = comment.blockTags) === null || _b === void 0 ? void 0 : _b.length) {
        const tags = comment.blockTags
            .filter((tag) => tag.tag !== '@returns')
            .map((tag) => {
            const tagName = (0, helpers_1.getTagName)(tag);
            const tagText = (0, utils_1.camelToTitleCase)(tagName);
            const tagMd = [
                headingLevel ? (0, els_1.heading)(headingLevel, tagText) : (0, els_1.backTicks)(tagText),
            ];
            tagMd.push(context.partials.commentParts(tag.content));
            return tagMd.join('\n\n');
        });
        md.push(tags.join('\n\n'));
    }
    return md.join('\n\n');
}
exports.comment = comment;
