"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hierarchy = void 0;
const els_1 = require("../support/els");
function hierarchy(context, declarationHierarchy) {
    const md = [];
    const parent = !declarationHierarchy.isTarget
        ? declarationHierarchy.types
            .map((hierarchyType) => {
            return getHierarchyType(hierarchyType, declarationHierarchy.isTarget || false, context);
        })
            .join('.')
        : null;
    if (declarationHierarchy.next) {
        declarationHierarchy.next.types.forEach((hierarchyType) => {
            var _a;
            const line = [];
            if (parent) {
                line.push(parent);
            }
            line.push(getHierarchyType(hierarchyType, ((_a = declarationHierarchy.next) === null || _a === void 0 ? void 0 : _a.isTarget) || false, context));
            md.push(line.join('.'));
        });
    }
    return (0, els_1.unorderedList)(md);
}
exports.hierarchy = hierarchy;
function getHierarchyType(hierarchyType, isTarget, context) {
    return isTarget
        ? (0, els_1.bold)((0, els_1.backTicks)(hierarchyType.toString()))
        : context.partials.someType(hierarchyType);
}
