"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.declarationMemberIdentifier = void 0;
const els_1 = require("../support/els");
const helpers_1 = require("../support/helpers");
const utils_1 = require("../support/utils");
function declarationMemberIdentifier(context, reflection) {
    var _a, _b;
    const md = [];
    const declarationType = (0, helpers_1.getDeclarationType)(reflection);
    if (((_a = reflection.flags) === null || _a === void 0 ? void 0 : _a.length) && !reflection.flags.isRest) {
        md.push(reflection.flags.map((flag) => (0, els_1.backTicks)(flag.toLowerCase())).join(' '));
    }
    if (reflection.flags.isRest) {
        md.push('...');
    }
    md.push(`${context.partials.declarationMemberName(reflection)}${declarationType ? ':' : ''}`);
    if (reflection.typeParameters) {
        md.push(`\\<${(_b = reflection.typeParameters) === null || _b === void 0 ? void 0 : _b.map((typeParameter) => (0, els_1.backTicks)(typeParameter.name)).join(', ')}\\>`);
    }
    if (declarationType) {
        md.push(`${context.partials.someType(declarationType, 'all')}`);
    }
    if (reflection.defaultValue && reflection.defaultValue !== '...') {
        md.push(` = \`${(0, utils_1.stripLineBreaks)((0, utils_1.stripComments)(reflection.defaultValue))}\``);
    }
    return md.join(' ');
}
exports.declarationMemberIdentifier = declarationMemberIdentifier;
