"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.declarationMemberName = void 0;
const els_1 = require("../support/els");
const utils_1 = require("../support/utils");
function declarationMemberName(context, declaration, emphasis = true) {
    var _a;
    if (Boolean(declaration.getSignature || Boolean(declaration.setSignature))) {
        if (declaration.getSignature) {
            return `${'get'} ${getName(`${declaration.getSignature.name}()`, emphasis)}`;
        }
        else if (declaration.setSignature) {
            return `${'set'} ${getName(declaration.setSignature.name, emphasis)}(${(_a = declaration.setSignature.parameters) === null || _a === void 0 ? void 0 : _a.map((parameter) => {
                return parameter.type
                    ? `${parameter.name}: ${context.partials.someType(parameter.type, 'all')}`
                    : '';
            })})`;
        }
    }
    return getName(declaration.name, emphasis);
}
exports.declarationMemberName = declarationMemberName;
function getName(name, emphasis) {
    if (emphasis) {
        return (0, els_1.bold)((0, utils_1.escapeChars)(name));
    }
    return (0, utils_1.escapeChars)(name);
}
