"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.navigation = void 0;
const els_1 = require("../support/els");
function navigation(context, project) {
    var _a;
    const md = [(0, els_1.heading)(2, 'Index')];
    const navigationItems = get(project)[0];
    (_a = navigationItems.children) === null || _a === void 0 ? void 0 : _a.forEach((navigationItem) => {
        md.push(`${(0, els_1.heading)(3, (0, els_1.link)(navigationItem.title, 'README.md'))}`);
        if (navigationItem.children) {
            navigationItem.children.forEach((child) => {
                md.push(`${(0, els_1.heading)(4, child.title)}`);
                if (child.children) {
                    const innerMd = child.children
                        .map((innerChild) => {
                        return '- ' + innerChild.title;
                    })
                        .join('\n');
                    md.push(innerMd);
                }
            });
        }
    });
    return md.join('\n');
}
exports.navigation = navigation;
function get(parent) {
    var _a;
    const navigation = (_a = ((parent === null || parent === void 0 ? void 0 : parent.groups) || parent.children)) === null || _a === void 0 ? void 0 : _a.reduce((prev, current) => {
        prev.push({
            title: current.name || current.title,
            url: current.url || null,
            children: get(current),
        });
        return prev;
    }, []);
    return navigation;
}
