"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toc = void 0;
const els_1 = require("../support/els");
const helpers_1 = require("../support/helpers");
const utils_1 = require("../support/utils");
function toc(context, reflection) {
    var _a, _b, _c;
    const md = [];
    const hideInPageTOC = context.getOption('hideInPageTOC');
    const isVisible = (_a = reflection.groups) === null || _a === void 0 ? void 0 : _a.some((group) => group.allChildrenHaveOwnDocument());
    function pushGroup(group) {
        const children = group.children.map((child) => `- [${(0, utils_1.escapeChars)(child.name)}](${context.relativeURL(child.url)})`);
        return children.join('\n');
    }
    if ((!hideInPageTOC && reflection.groups) ||
        (isVisible && reflection.groups)) {
        const headingLevel = (0, helpers_1.getIndexHeadingLevel)(reflection, context.getOption('groupByKinds'));
        const subHeadingLevel = headingLevel + 1;
        md.push((0, els_1.heading)(headingLevel, 'Index') + '\n\n');
        if ((_b = reflection.categories) === null || _b === void 0 ? void 0 : _b.length) {
            reflection.categories.forEach((item) => {
                md.push((0, els_1.heading)(subHeadingLevel, item.title));
                md.push(pushGroup(item));
            });
        }
        else if ((_c = reflection.groups) === null || _c === void 0 ? void 0 : _c.length) {
            reflection.groups.forEach((item) => {
                if (item.categories) {
                    md.push((0, els_1.heading)(subHeadingLevel, item.title));
                    item.categories.forEach((item2) => {
                        md.push((0, els_1.heading)(subHeadingLevel + 1, `${item2.title}`));
                        md.push(pushGroup(item2));
                    });
                }
                else {
                    if (!hideInPageTOC || item.allChildrenHaveOwnDocument()) {
                        md.push((0, els_1.heading)(subHeadingLevel, item.title) + '\n\n');
                        md.push(pushGroup(item));
                        md.push('\n');
                    }
                }
            });
        }
    }
    return md.length > 0 ? md.join('\n') : '';
}
exports.toc = toc;
