"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.declarationType = void 0;
const els_1 = require("../support/els");
const helpers_1 = require("../support/helpers");
function declarationType(context, declarationReflection, collapse = 'none') {
    if (collapse === 'object' || collapse === 'all') {
        return (0, els_1.backTicks)('object');
    }
    if (declarationReflection.indexSignature || declarationReflection.children) {
        let indexSignature = '';
        const declarationIndexSignature = declarationReflection.indexSignature;
        if (declarationIndexSignature) {
            const key = declarationIndexSignature.parameters
                ? declarationIndexSignature.parameters.map((param) => `\`[${param.name}: ${param.type}]\``)
                : '';
            const obj = context.partials.someType(declarationIndexSignature.type);
            indexSignature = `${key}: ${obj}; `;
        }
        const types = declarationReflection.children &&
            declarationReflection.children.map((obj) => {
                return `${context.partials.declarationMemberName(obj, false)}: ${context.partials.someType((0, helpers_1.getDeclarationType)(obj))};`;
            });
        if (indexSignature) {
            types === null || types === void 0 ? void 0 : types.unshift(indexSignature);
        }
        return types ? `\\{${types.join('\n')}}` : '\\{}';
    }
    return '\\{}';
}
exports.declarationType = declarationType;
