"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.functionType = void 0;
function functionType(context, modelSignatures) {
    const functions = modelSignatures.map((fn) => {
        const typeParams = fn.typeParameters
            ? `\\<${fn.typeParameters
                .map((typeParameter) => typeParameter.name)
                .join(', ')}\\>`
            : [];
        const params = fn.parameters
            ? fn.parameters.map((param) => {
                return `${param.flags.isRest ? '...' : ''}\`${param.name}${param.flags.isOptional ? '?' : ''}\`: ${context.partials.someType(param.type)}`;
            })
            : [];
        const returns = context.partials.someType(fn.type);
        return typeParams + `(${params.join(', ')}) => ${returns}`;
    });
    return functions.join('');
}
exports.functionType = functionType;
