"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.partials = exports.templates = void 0;
const member_1 = require("./templates/member");
const project_1 = require("./templates/project");
const readme_1 = require("./templates/readme");
const reflection_1 = require("./templates/reflection");
const breadcrumbs_1 = require("./partials/breadcrumbs");
const comment_parts_1 = require("./partials/comment.parts");
const comment_1 = require("./partials/comment");
const frontmatter_1 = require("./partials/frontmatter");
const hierarchy_1 = require("./partials/hierarchy");
const member_declaration_identifier_1 = require("./partials/member.declaration.identifier");
const member_declaration_name_1 = require("./partials/member.declaration.name");
const member_declaration_1 = require("./partials/member.declaration");
const member_indexsignature_title_1 = require("./partials/member.indexsignature.title");
const member_inheritance_1 = require("./partials/member.inheritance");
const member_reference_1 = require("./partials/member.reference");
const member_reflection_1 = require("./partials/member.reflection");
const member_signature_identifier_1 = require("./partials/member.signature.identifier");
const member_signature_1 = require("./partials/member.signature");
const member_sources_1 = require("./partials/member.sources");
const member_2 = require("./partials/member");
const member_typedeclaration_1 = require("./partials/member.typedeclaration");
const members_1 = require("./partials/members");
const navigation_1 = require("./partials/navigation");
const page_title_1 = require("./partials/page.title");
const table_enum_members_1 = require("./partials/table.enum-members");
const table_parameters_1 = require("./partials/table.parameters");
const table_properties_1 = require("./partials/table.properties");
const table_typeparameters_1 = require("./partials/table.typeparameters");
const toc_1 = require("./partials/toc");
const type_array_1 = require("./partials/type.array");
const type_conditional_1 = require("./partials/type.conditional");
const type_declaration_1 = require("./partials/type.declaration");
const type_function_1 = require("./partials/type.function");
const type_index_access_1 = require("./partials/type.index-access");
const type_inferred_1 = require("./partials/type.inferred");
const type_intersection_1 = require("./partials/type.intersection");
const type_intrinsic_1 = require("./partials/type.intrinsic");
const type_literal_1 = require("./partials/type.literal");
const type_query_1 = require("./partials/type.query");
const type_reference_1 = require("./partials/type.reference");
const type_reflection_1 = require("./partials/type.reflection");
const type_some_1 = require("./partials/type.some");
const type_tuple_1 = require("./partials/type.tuple");
const type_type_operator_1 = require("./partials/type.type-operator");
const type_union_1 = require("./partials/type.union");
const type_unknown_1 = require("./partials/type.unknown");
function bind(fn, first) {
    return (...r) => fn(first, ...r);
}
const templates = (context) => ({
    memberTemplate: bind(member_1.memberTemplate, context),
    projectTemplate: bind(project_1.projectTemplate, context),
    readmeTemplate: bind(readme_1.readmeTemplate, context),
    reflectionTemplate: bind(reflection_1.reflectionTemplate, context),
});
exports.templates = templates;
const partials = (context) => ({
    breadcrumbs: bind(breadcrumbs_1.breadcrumbs, context),
    commentParts: bind(comment_parts_1.commentParts, context),
    comment: bind(comment_1.comment, context),
    frontmatter: bind(frontmatter_1.frontmatter, context),
    hierarchy: bind(hierarchy_1.hierarchy, context),
    declarationMemberIdentifier: bind(member_declaration_identifier_1.declarationMemberIdentifier, context),
    declarationMemberName: bind(member_declaration_name_1.declarationMemberName, context),
    declarationMember: bind(member_declaration_1.declarationMember, context),
    indexSignatureTitle: bind(member_indexsignature_title_1.indexSignatureTitle, context),
    inheritance: bind(member_inheritance_1.inheritance, context),
    referenceMember: bind(member_reference_1.referenceMember, context),
    reflectionMember: bind(member_reflection_1.reflectionMember, context),
    signatureMemberIdentifier: bind(member_signature_identifier_1.signatureMemberIdentifier, context),
    signatureMember: bind(member_signature_1.signatureMember, context),
    sources: bind(member_sources_1.sources, context),
    member: bind(member_2.member, context),
    typeDeclarationMember: bind(member_typedeclaration_1.typeDeclarationMember, context),
    members: bind(members_1.members, context),
    navigation: bind(navigation_1.navigation, context),
    pageTitle: bind(page_title_1.pageTitle, context),
    enumMembersTable: bind(table_enum_members_1.enumMembersTable, context),
    parametersTable: bind(table_parameters_1.parametersTable, context),
    propertiesTable: bind(table_properties_1.propertiesTable, context),
    typeParametersTable: bind(table_typeparameters_1.typeParametersTable, context),
    toc: bind(toc_1.toc, context),
    arrayType: bind(type_array_1.arrayType, context),
    conditionalType: bind(type_conditional_1.conditionalType, context),
    declarationType: bind(type_declaration_1.declarationType, context),
    functionType: bind(type_function_1.functionType, context),
    indexAccessType: bind(type_index_access_1.indexAccessType, context),
    inferredType: bind(type_inferred_1.inferredType, context),
    intersectionType: bind(type_intersection_1.intersectionType, context),
    intrinsicType: bind(type_intrinsic_1.intrinsicType, context),
    literalType: bind(type_literal_1.literalType, context),
    queryType: bind(type_query_1.queryType, context),
    referenceType: bind(type_reference_1.referenceType, context),
    reflectionType: bind(type_reflection_1.reflectionType, context),
    someType: bind(type_some_1.someType, context),
    tupleType: bind(type_tuple_1.tupleType, context),
    typeOperatorType: bind(type_type_operator_1.typeOperatorType, context),
    unionType: bind(type_union_1.unionType, context),
    unknownType: bind(type_unknown_1.unknownType, context),
});
exports.partials = partials;
