"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memberTemplate = void 0;
const typedoc_1 = require("typedoc");
const els_1 = require("../support/els");
function memberTemplate(context, page) {
    const md = [];
    if (context.getOption('enableFrontmatter')) {
        md.push(context.partials.frontmatter(page));
    }
    if (!context.getOption('hideBreadcrumbs')) {
        md.push(context.partials.breadcrumbs(page));
    }
    if (!context.getOption('hidePageTitle')) {
        md.push((0, els_1.heading)(1, context.partials.pageTitle(page)));
    }
    if (!context.getOption('hideKindTag') &&
        !page.model.kindOf([typedoc_1.ReflectionKind.Module, typedoc_1.ReflectionKind.Namespace])) {
        md.push((0, els_1.bold)((0, els_1.backTicks)(typedoc_1.ReflectionKind.singularString(page.model.kind))));
    }
    md.push(context.partials.member(page.model));
    return md.join('\n\n');
}
exports.memberTemplate = memberTemplate;
