"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.projectTemplate = void 0;
const els_1 = require("../support/els");
function projectTemplate(context, page) {
    const md = [];
    if (context.getOption('enableFrontmatter')) {
        md.push(context.partials.frontmatter(page));
    }
    if (!context.getOption('hidePageTitle')) {
        md.push((0, els_1.heading)(1, context.partials.pageTitle(page)));
    }
    if (page.model.comment) {
        md.push(context.partials.comment(page.model.comment, 2));
    }
    md.push(context.partials.toc(page.model));
    md.push(context.partials.members(page.model));
    return md.join('\n\n');
}
exports.projectTemplate = projectTemplate;
