import { DeclarationReflection, Options, PageEvent, ProjectReflection, UrlMapping } from 'typedoc';
import { NavigationItem, TemplateMapping, TypedocPluginMarkdownOptions } from './models';
import { MarkdownTheme } from './theme';
export declare class MarkdownThemeConverterContext {
    theme: MarkdownTheme;
    options: Options;
    private _urls;
    private _anchors;
    constructor(theme: MarkdownTheme, options: Options);
    getOption<K extends keyof TypedocPluginMarkdownOptions>(name: K): TypedocPluginMarkdownOptions[K];
    readmeTemplate: (pageEvent: PageEvent<ProjectReflection>) => string;
    projectTemplate: (pageEvent: PageEvent<ProjectReflection>) => string;
    reflectionTemplate: (pageEvent: PageEvent<DeclarationReflection>) => string;
    memberTemplate: (pageEvent: PageEvent<DeclarationReflection>) => string;
    getUrls(project: ProjectReflection): UrlMapping[];
    getNavigation(project: ProjectReflection): NavigationItem[];
    private getNavigationGroups;
    private buildUrls;
    private getUrl;
    private childrenIncludeNamespaces;
    private getAliasPrefix;
    private getNamespaces;
    private applyAnchorUrl;
    private getAnchorId;
    get mappings(): Record<number, TemplateMapping>;
}
