import * as prettier from 'prettier';
import { PageEvent, ProjectReflection, Reflection, RenderTemplate, Renderer, Theme } from 'typedoc';
import { MarkdownThemeConverterContext } from './theme-converter-context';
import { MarkdownThemeRenderContext } from './theme-render-context';
export declare class MarkdownTheme extends Theme {
    private _renderContext;
    private _converterContext;
    private _prettierOptions;
    constructor(renderer: Renderer);
    getRenderContext(): MarkdownThemeRenderContext;
    getConverterContext(): MarkdownThemeConverterContext;
    getPrettierOptions(): prettier.Options | null;
    resolvePrettierOptions(): prettier.Options | null;
    render(page: PageEvent<Reflection>, template: RenderTemplate<PageEvent<Reflection>>): string;
    getUrls(project: ProjectReflection): import("typedoc").UrlMapping<any>[];
    getNavigation(project: ProjectReflection): import("./models").NavigationItem[];
    protected onBeginPage(page: PageEvent): void;
}
