"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkdownTheme = void 0;
const prettier = __importStar(require("prettier"));
const typedoc_1 = require("typedoc");
const theme_converter_context_1 = require("./theme-converter-context");
const theme_render_context_1 = require("./theme-render-context");
class MarkdownTheme extends typedoc_1.Theme {
    constructor(renderer) {
        super(renderer);
        this.listenTo(this.owner, {
            [typedoc_1.PageEvent.BEGIN]: this.onBeginPage,
        });
    }
    getRenderContext() {
        if (!this._renderContext) {
            this._renderContext = new theme_render_context_1.MarkdownThemeRenderContext(this, this.application.options);
        }
        return this._renderContext;
    }
    getConverterContext() {
        if (!this._converterContext) {
            this._converterContext = new theme_converter_context_1.MarkdownThemeConverterContext(this, this.application.options);
        }
        return this._converterContext;
    }
    getPrettierOptions() {
        if (!this._prettierOptions) {
            this._prettierOptions = this.resolvePrettierOptions();
        }
        return this._prettierOptions;
    }
    resolvePrettierOptions() {
        const prettierFile = prettier.resolveConfigFile.sync();
        return prettierFile ? prettier.resolveConfig.sync(prettierFile) : null;
    }
    render(page, template) {
        return prettier.format(template(page), {
            ...this.getPrettierOptions(),
            parser: 'markdown',
        });
    }
    getUrls(project) {
        return this.getConverterContext().getUrls(project);
    }
    getNavigation(project) {
        return this.getConverterContext().getNavigation(project);
    }
    onBeginPage(page) {
        this.getRenderContext().activeLocation = page.url;
    }
}
exports.MarkdownTheme = MarkdownTheme;
